unit Unit1;

interface
{$WARN UNIT_PLATFORM OFF}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Outils, FileCtrl, ComCtrls, ShellCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    Compresser: TButton;
    Edit2: TEdit;
    Button3: TButton;
    ShellTreeView1: TShellTreeView;
    ShellListView1: TShellListView;
    ListBox1: TListBox;
    Button2: TButton;
    Button4: TButton;
    SaveDialog1: TSaveDialog;
    TabSheet2: TTabSheet;
    OpenDialog1: TOpenDialog;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button5: TButton;
    Edit3: TEdit;
    Decompresser: TButton;
    Label6: TLabel;
    procedure CompresserClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ShellListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure ShellListView1AddFolder(Sender: TObject;
      AFolder: TShellFolder; var CanAdd: Boolean);
    procedure DecompresserClick(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ShellListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ShellListView1DblClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses tarbz2;

//////////////////////////////////////

procedure TForm1.CompresserClick(Sender: TObject);
begin
     Compresser.Enabled:=false;
     if CompresserTarBz2(ListBox1.Items, Edit2.Text) then ShowMessage('Russi !') else ShowMessage('Erreur !');
     Compresser.Enabled:=true;
end;

procedure TForm1.DecompresserClick(Sender: TObject);
begin
     Decompresser.Enabled:=false;
     if DecompresserTarBz2(Edit1.Text, Edit3.Text) then ShowMessage('Russi !') else ShowMessage('Erreur !');
     Decompresser.Enabled:=true;
end;
//////////////////////////////////////


procedure TForm1.FormCreate(Sender: TObject);
begin
     SaveDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
     OpenDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
     Edit2.Text:=ExtractFilePath(ParamStr(0))+'test.tar.bz2';
     Edit3.Text:=ExtractFilePath(ParamStr(0));
end;

// Page Compression

procedure TForm1.Button2Click(Sender: TObject);
var i: integer;
begin
     for i:=0 to ShellListView1.Items.Count-1 do
          if ShellListView1.Items[i].Selected then
             ListBox1.Items.Add(ShellListView1.Folders[ShellListView1.Items[i].Index].PathName);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     if SaveDialog1.Execute then Edit2.Text:=SaveDialog1.FileName;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
     Compresser.Enabled:=DirectoryExists(ExtractFilePath(Edit2.Text));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin ListBox1.Clear; end;

procedure TForm1.ShellListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
     Button2.Enabled:=ShellListView1.SelCount>0;
end;

procedure TForm1.ShellListView1AddFolder(Sender: TObject; AFolder: TShellFolder; var CanAdd: Boolean);
begin Button2.Enabled:=ShellListView1.SelCount>0; end;

procedure TForm1.ShellListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin if Key=VK_RETURN then Button2Click(Sender); end;

procedure TForm1.ShellListView1DblClick(Sender: TObject);
begin Button2Click(Sender); end;

// Page dcompression

procedure TForm1.Button5Click(Sender: TObject);
var DossierChoisi: string;
begin
     if SelectDirectory('Slectionnez le rpertoire de dcompression :', '', DossierChoisi)
        then Edit3.Text:=DossierChoisi;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
     Decompresser.Enabled:=FileExists(Edit1.Text);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     if OpenDialog1.Execute then Edit1.Text:=OpenDialog1.FileName;
end;

end.
